diff -uNrd ircd-hybrid-6.4.1/src/m_oper.c ircd-hyb6.4.1-FDFr5.4/src/m_oper.c
--- ircd-hybrid-6.4.1/src/m_oper.c	Mon Jun 23 23:57:16 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_oper.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_oper.c,v 1.18 2003/06/24 03:57:16 ievil Exp $
+ *   $Id: m_oper.c,v 1.3 2003/10/09 03:49:54 jailbird Exp $
  */
 
 #include "m_commands.h"
@@ -244,21 +244,13 @@
 
       if (IsSetOperAdmin(sptr) )
         {
-#ifdef CUSTOM_ERR
           sendto_ops("%s (%s@%s) has just acquired the personality of a petty megalomaniacal tyrant [IRC Admin]", parv[0],
-#else
-          sendto_ops("%s (%s@%s) is now administrator", parv[0],
-#endif /* CUSTOM_ERR */
           sptr->username, sptr->host);
         }
       else
         {
 
-#ifdef CUSTOM_ERR
-      sendto_ops("%s (%s@%s) has just acquired the personality of a petty megalomaniacal tyrant [IRC(%c)p]", parv[0],
-#else
-      sendto_ops("%s (%s@%s) is now operator (%c)", parv[0],
-#endif /* CUSTOM_ERR */
+          sendto_ops("%s (%s@%s) has just acquired the personality of a petty megalomaniacal tyrant [IRC(%c)p]", parv[0],
                  sptr->username, sptr->host,
                  IsOper(sptr) ? 'O' : 'o');
         }                 
diff -uNrd ircd-hybrid-6.4.1/src/m_operspylog.c ircd-hyb6.4.1-FDFr5.4/src/m_operspylog.c
--- ircd-hybrid-6.4.1/src/m_operspylog.c	Mon Aug 25 17:21:54 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_operspylog.c	Wed Oct 15 20:38:22 2003
@@ -19,7 +19,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_operspylog.c,v 1.6 2003/08/25 21:21:54 ievil Exp $
+ *   $Id: m_operspylog.c,v 1.1.1.1 2003/10/09 02:47:14 jailbird Exp $
  */
 
 #include "m_operspylog.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_operwall.c ircd-hyb6.4.1-FDFr5.4/src/m_operwall.c
--- ircd-hybrid-6.4.1/src/m_operwall.c	Wed Oct 17 11:13:31 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/m_operwall.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_operwall.c,v 1.3 2001/10/17 15:13:31 db Exp $
+ *   $Id: m_operwall.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_pass.c ircd-hyb6.4.1-FDFr5.4/src/m_pass.c
--- ircd-hybrid-6.4.1/src/m_pass.c	Sun Jun  3 21:31:33 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/m_pass.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: m_pass.c,v 1.4 2001/06/04 01:31:33 greg Exp $
+ *  $Id: m_pass.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "m_commands.h"  /* m_pass prototype */
 #include "client.h"      /* client struct */
diff -uNrd ircd-hybrid-6.4.1/src/m_ping.c ircd-hyb6.4.1-FDFr5.4/src/m_ping.c
--- ircd-hybrid-6.4.1/src/m_ping.c	Thu Jul 29 23:25:51 1999
+++ ircd-hyb6.4.1-FDFr5.4/src/m_ping.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_ping.c,v 1.1 1999/07/30 03:25:51 db Exp $
+ *   $Id: m_ping.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_pong.c ircd-hyb6.4.1-FDFr5.4/src/m_pong.c
--- ircd-hybrid-6.4.1/src/m_pong.c	Thu Nov 29 01:44:29 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/m_pong.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_pong.c,v 1.3 2001/11/29 06:44:29 db Exp $
+ *   $Id: m_pong.c,v 1.4 2003/05/30 00:18:25 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
@@ -28,6 +28,8 @@
 #include "numeric.h"
 #include "send.h"
 #include "channel.h"
+#include "s_stats.h"
+#include "s_user.h"
 #include "irc_string.h"
 
 #ifdef DEBUGMODE
@@ -113,6 +115,37 @@
 
   origin = parv[1];
   destination = parv[2];
+
+#ifdef ANTI_IP_SPOOF
+  /* ANTI_IP_SPOOF delays the registration of a local client until after we
+ *      have received a response from a PING containing a random integer.  When
+ *           we receive the resulting PONG, then we register the client.
+ *             */
+
+  if(MyConnect(sptr) && !IsRegisteredUser(sptr) && sptr->random_ping) {
+      int received_random_ping;
+      received_random_ping = (int)atoi(origin);
+
+      if(received_random_ping) {
+          /* Ensure that aClient has a user and a nick (redundant) */
+          if((sptr->user) && (sptr->name[0])) {
+              if(received_random_ping == sptr->random_ping) {
+                  char buf[USERLEN + 1];
+                  strncpy_irc(buf, sptr->username, USERLEN);
+                  buf[USERLEN] = '\0';
+
+                  sptr->flags2 |= FLAGS2_GOT_ANTI_SPOOF_PING;
+                  sptr->flags &= ~FLAGS_PINGSENT;
+                  register_user(cptr, sptr, sptr->name, buf);
+                  return 0;
+              } else {
+                 ServerStats->is_ipspoof++;
+                 return exit_client(cptr,sptr,&me,"Wrong randon PONG response.");
+              }
+          }
+      }
+  }
+#endif
 
   /* Now attempt to route the PONG, comstud pointed out routable PING
    * is used for SPING.  routable PING should also probably be left in
diff -uNrd ircd-hybrid-6.4.1/src/m_quit.c ircd-hyb6.4.1-FDFr5.4/src/m_quit.c
--- ircd-hybrid-6.4.1/src/m_quit.c	Sat Jun 14 15:48:19 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_quit.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_quit.c,v 1.6 2003/06/14 19:48:19 ievil Exp $
+ *   $Id: m_quit.c,v 1.1.1.2 2003/10/09 02:47:14 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_rehash.c ircd-hyb6.4.1-FDFr5.4/src/m_rehash.c
--- ircd-hybrid-6.4.1/src/m_rehash.c	Mon Jun 23 23:57:16 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_rehash.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_rehash.c,v 1.10 2003/06/24 03:57:16 ievil Exp $
+ *   $Id: m_rehash.c,v 1.4 2003/10/09 03:49:54 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
@@ -117,11 +117,7 @@
       if (irccmp(parv[1],"DNS") == 0)
         {
           sendto_one(sptr, form_str(RPL_REHASHING), me.name, parv[0], "DNS");
-#ifdef CUSTOM_ERR
           sendto_ops("%s is rehashing DNS while whistling innocently",
-#else
-          sendto_ops("%s is rehashing DNS",
-#endif
                  parv[0]);
           restart_resolver();   /* re-read /etc/resolv.conf AGAIN?
                                    and close/re-open res socket */
@@ -137,15 +133,10 @@
 		    }
           sendto_one(sptr, form_str(RPL_REHASHING), me.name, parv[0], "temp klines");
           flush_temp_klines();
-#ifdef CUSTOM_ERR
           sendto_ops("%s is clearing temp klines while whistling innocently",
-#else
-          sendto_ops("%s is clearing temp klines",
-#endif
                  parv[0]);
           found = YES;
         }
-#ifdef GLINES
       else if(irccmp(parv[1],"GLINES") == 0)
         {
           /* i submitted this bug a while ago .. people without G should not
@@ -158,24 +149,15 @@
 
           sendto_one(sptr, form_str(RPL_REHASHING), me.name, parv[0], "g-lines");
           flush_glines();
-#ifdef CUSTOM_ERR
           sendto_ops("%s is clearing G-lines while whistling innocently",
-#else
-          sendto_ops("%s is clearing G-lines",
-#endif
                  parv[0]);
           found = YES;
         }
-#endif
       else if(irccmp(parv[1],"GC") == 0)
         {
           sendto_one(sptr, form_str(RPL_REHASHING), me.name, parv[0], "garbage collecting");
           block_garbage_collect();
-#ifdef CUSTOM_ERR
           sendto_ops("%s is garbage collecting while whistling innocently",
-#else
-          sendto_ops("%s is garbage collecting",
-#endif
                  parv[0]);
           found = YES;
         }
@@ -208,11 +190,7 @@
           sendto_one(sptr, form_str(RPL_REHASHING), me.name, parv[0],
                      ConfigFileEntry.configfile);
           /* this does a full rehash right now, so report it as such */
-#ifdef CUSTOM_ERR
           sendto_ops("%s is rehashing dlines from server config file while whistling innocently",
-#else
-          sendto_ops("%s is rehashing dlines from server config file",
-#endif
                      parv[0]);
           ilog(L_NOTICE, "REHASH From %s\n", get_client_name(sptr, HIDE_IP));
           dline_in_progress = 1;
@@ -226,13 +204,8 @@
         }
       else
         {
-#ifdef GLINES
           sendto_one(sptr, ":%s NOTICE %s :Rehash one of: DNS, TKLINES, GLINES, GC, HELP, MOTD, OMOTD, DUMP, DLINES",
 	                 me.name, sptr->name);
-#else
-          sendto_one(sptr, ":%s NOTICE %s :Rehash one of: DNS, TKLINES, GC, HELP, MOTD, OMOTD, DUMP, DLINES", 
-	                 me.name, sptr->name);
-#endif
           return(0);
         }
     }
@@ -240,11 +213,7 @@
     {
       sendto_one(sptr, form_str(RPL_REHASHING), me.name, parv[0],
                  ConfigFileEntry.configfile);
-#ifdef CUSTOM_ERR
       sendto_ops("%s is rehashing server config file while whistling innocently",
-#else
-      sendto_ops("%s is rehashing server config file",
-#endif
                  parv[0]);
       ilog(L_NOTICE, "REHASH From %s\n", get_client_name(sptr, SHOW_IP));
       return rehash(cptr, sptr, 0);
diff -uNrd ircd-hybrid-6.4.1/src/m_restart.c ircd-hyb6.4.1-FDFr5.4/src/m_restart.c
--- ircd-hybrid-6.4.1/src/m_restart.c	Mon Jun 23 23:57:16 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_restart.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_restart.c,v 1.6 2003/06/24 03:57:16 ievil Exp $
+ *   $Id: m_restart.c,v 1.1.1.2 2003/10/09 02:47:14 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_server.c ircd-hyb6.4.1-FDFr5.4/src/m_server.c
--- ircd-hybrid-6.4.1/src/m_server.c	Mon Jun 23 23:57:16 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_server.c	Sun Oct 26 13:01:19 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_server.c,v 1.16 2003/06/24 03:57:16 ievil Exp $
+ *   $Id: m_server.c,v 1.4 2003/10/09 03:49:54 jailbird Exp $
  */
 #include "m_commands.h"  /* m_server prototype */
 #include "client.h"      /* client struct */
@@ -467,6 +467,16 @@
 #endif		 
       return exit_client(cptr, cptr, cptr, "Non-TS server");
     }
+
+  /*            
+   * Reject the server if we did not get a CAPAB stating that this
+   * server supports the FDFnet protocol -JailBird
+   */
+  if(!IsCapable(cptr,CAP_FDF)) {
+        sendto_ops("Link %s dropped, non-FDF server",
+                   get_client_name(cptr, TRUE));
+        return exit_client(cptr, cptr, cptr, "Non-FDF server");
+  }
 
   /*
    * if we are connecting (Handshake), we already have the name from the
diff -uNrd ircd-hybrid-6.4.1/src/m_set.c ircd-hyb6.4.1-FDFr5.4/src/m_set.c
--- ircd-hybrid-6.4.1/src/m_set.c	Sun May  4 13:52:45 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_set.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_set.c,v 1.9 2003/05/04 17:52:45 db Exp $
+ *   $Id: m_set.c,v 1.1.1.2 2003/10/09 02:47:14 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_squit.c ircd-hyb6.4.1-FDFr5.4/src/m_squit.c
--- ircd-hybrid-6.4.1/src/m_squit.c	Mon Jun 23 23:57:16 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_squit.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_squit.c,v 1.5 2003/06/24 03:57:16 ievil Exp $
+ *   $Id: m_squit.c,v 1.1.1.2 2003/10/09 02:47:14 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_stats.c ircd-hyb6.4.1-FDFr5.4/src/m_stats.c
--- ircd-hybrid-6.4.1/src/m_stats.c	Wed Nov 27 23:18:01 2002
+++ ircd-hyb6.4.1-FDFr5.4/src/m_stats.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: m_stats.c,v 1.22 2002/11/28 04:18:01 db Exp $
+ *  $Id: m_stats.c,v 1.4 2003/10/09 03:49:54 jailbird Exp $
  */
 #include "m_commands.h"  /* m_pass prototype */
 #include "class.h"       /* report_classes */
@@ -314,13 +314,8 @@
           valid_stats++;
           break;
         }
-#ifdef GLINES
       report_glines(sptr);
       valid_stats++;
-#else
-      sendto_one(sptr,":%s NOTICE %s :This server does not support G lines",
-               me.name, parv[0]);
-#endif
       break;
 
     case 'H' : case 'h' :
@@ -455,7 +450,15 @@
       valid_stats++;
       break;
 
-    case 'S' : case 's':
+    case 'S' :
+      if (IsAnOper(sptr))
+          report_specials(sptr,CONF_SLINE,RPL_STATSSLINE);
+      else
+        sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+      valid_stats++;
+      break;
+
+    case 's':
       if (IsAnOper(sptr))
         list_scache(cptr,sptr,parc,parv);
       else
diff -uNrd ircd-hybrid-6.4.1/src/m_svinfo.c ircd-hyb6.4.1-FDFr5.4/src/m_svinfo.c
--- ircd-hybrid-6.4.1/src/m_svinfo.c	Fri Jul 27 20:49:52 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/m_svinfo.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_svinfo.c,v 1.6 2001/07/28 00:49:52 leeh Exp $
+ *   $Id: m_svinfo.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_time.c ircd-hyb6.4.1-FDFr5.4/src/m_time.c
--- ircd-hybrid-6.4.1/src/m_time.c	Fri Jul 30 02:40:16 1999
+++ ircd-hyb6.4.1-FDFr5.4/src/m_time.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_time.c,v 1.1 1999/07/30 06:40:16 tomh Exp $
+ *   $Id: m_time.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_trace.c ircd-hyb6.4.1-FDFr5.4/src/m_trace.c
--- ircd-hybrid-6.4.1/src/m_trace.c	Wed Dec 19 18:02:06 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/m_trace.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_trace.c,v 1.12 2001/12/19 23:02:06 leeh Exp $
+ *   $Id: m_trace.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "m_commands.h"
 #include "class.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_undline.c ircd-hyb6.4.1-FDFr5.4/src/m_undline.c
--- ircd-hybrid-6.4.1/src/m_undline.c	Mon Jun 23 23:57:16 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_undline.c	Wed Oct 15 20:38:22 2003
@@ -21,7 +21,7 @@
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  *
- *   $Id: m_undline.c,v 1.2 2003/06/24 03:57:16 ievil Exp $
+ *   $Id: m_undline.c,v 1.1.1.1 2003/10/09 02:47:14 jailbird Exp $
  */
 #include "m_commands.h"
 #include "channel.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_ungline.c ircd-hyb6.4.1-FDFr5.4/src/m_ungline.c
--- ircd-hybrid-6.4.1/src/m_ungline.c	Mon Jun 23 23:57:16 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_ungline.c	Wed Oct 15 20:38:23 2003
@@ -21,7 +21,7 @@
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  *
- *   $Id: m_ungline.c,v 1.2 2003/06/24 03:57:16 ievil Exp $
+ *   $Id: m_ungline.c,v 1.3 2003/10/10 04:45:49 jailbird Exp $
  */
 #include "m_commands.h"
 #include "channel.h"
@@ -38,9 +38,7 @@
 #include "s_misc.h"
 #include "send.h"
 #include "struct.h"
-#ifdef GLINES
 #include "m_gline.h"
-#endif
 
 #include <stdio.h>
 #include <time.h>
@@ -60,7 +58,6 @@
 int
 m_ungline (aClient *cptr,aClient *sptr,int parc,char *parv[])
 {
-#ifdef GLINES
 
   char  *user,*host;
 
@@ -69,14 +66,14 @@
       return -1;
     }
 
-  if (!IsOper(sptr))
+  if (!IsOper(sptr)&&!IsSLine(sptr))
     {
       sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name,
                  parv[0]);
       return 0;
     }
 
-  if (!IsSetOperUnkline(sptr) || !IsSetOperGline(sptr))
+  if ((!IsSetOperUnkline(sptr) || !IsSetOperGline(sptr))&&!IsSLine(sptr))
     {
       sendto_one(sptr,":%s NOTICE %s :You have no U and G flag",
                  me.name,parv[0]);
@@ -128,8 +125,5 @@
                  me.name, parv[0],user,host);
       return 0;
     }
-#else
-  sendto_one(sptr,":%s NOTICE %s :UNGLINE disabled",me.name,parv[0]);
-#endif
   return 0;
 }
diff -uNrd ircd-hybrid-6.4.1/src/m_unkline.c ircd-hyb6.4.1-FDFr5.4/src/m_unkline.c
--- ircd-hybrid-6.4.1/src/m_unkline.c	Mon Jun 23 23:57:16 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_unkline.c	Wed Oct 15 20:38:22 2003
@@ -21,7 +21,7 @@
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  *
- *   $Id: m_unkline.c,v 1.54 2003/06/24 03:57:16 ievil Exp $
+ *   $Id: m_unkline.c,v 1.4 2003/10/09 03:49:54 jailbird Exp $
  */
 #include "m_commands.h"
 #include "channel.h"
@@ -39,6 +39,7 @@
 #include "s_serv.h"
 #include "send.h"
 #include "struct.h"
+#include "m_gline.h"
 
 #include <stdio.h>
 #include <time.h>
diff -uNrd ircd-hybrid-6.4.1/src/m_userhost.c ircd-hyb6.4.1-FDFr5.4/src/m_userhost.c
--- ircd-hybrid-6.4.1/src/m_userhost.c	Tue Jan  2 00:48:18 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/m_userhost.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_userhost.c,v 1.10 2001/01/02 05:48:18 lusky Exp $
+ *   $Id: m_userhost.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 
 #include "m_commands.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_users.c ircd-hyb6.4.1-FDFr5.4/src/m_users.c
--- ircd-hybrid-6.4.1/src/m_users.c	Thu Jul 29 03:11:49 1999
+++ ircd-hyb6.4.1-FDFr5.4/src/m_users.c	Wed Oct 15 20:38:23 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_users.c,v 1.1 1999/07/29 07:11:49 tomh Exp $
+ *   $Id: m_users.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_version.c ircd-hyb6.4.1-FDFr5.4/src/m_version.c
--- ircd-hybrid-6.4.1/src/m_version.c	Thu Aug 21 19:59:26 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_version.c	Wed Oct 15 20:38:23 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_version.c,v 1.13 2003/08/21 23:59:26 ievil Exp $
+ *   $Id: m_version.c,v 1.1.1.2 2003/10/09 02:47:14 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_wallops.c ircd-hyb6.4.1-FDFr5.4/src/m_wallops.c
--- ircd-hybrid-6.4.1/src/m_wallops.c	Wed Oct 17 11:13:31 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/m_wallops.c	Wed Oct 15 20:38:23 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_wallops.c,v 1.3 2001/10/17 15:13:31 db Exp $
+ *   $Id: m_wallops.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_who.c ircd-hyb6.4.1-FDFr5.4/src/m_who.c
--- ircd-hybrid-6.4.1/src/m_who.c	Sat Jun 14 19:23:42 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_who.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_who.c,v 1.6 2003/06/14 23:23:42 ievil Exp $
+ *   $Id: m_who.c,v 1.3 2003/10/09 03:49:54 jailbird Exp $
  */
 
 #include "m_commands.h"
@@ -209,10 +209,12 @@
       if (chptr)
         {
           member = IsMember(sptr, chptr)
+#ifdef OPERS_SEE_INVISIBLE
+		   || IsAnOper(sptr);
+#endif  
 #ifdef OPERSPY
                    || OperSpyWho
 #endif
-                   ;
           if (member || !SecretChannel(chptr))
             for (lp = chptr->members; lp; lp = lp->next)
               {
@@ -235,6 +237,11 @@
 #endif
       isinvis = IsInvisible(acptr);
 
+      isinvis = IsInvisible(acptr)
+#ifdef OPERS_SEE_INVISIBLE
+                && !IsAnOper(sptr)
+#endif
+                ; 
       for (lp = acptr->user->channel; lp; lp = lp->next)
         {
           chptr = lp->value.chptr;
@@ -260,6 +267,12 @@
         continue;
       
       showperson = 0;
+#ifdef OPERS_SEE_INVISIBLE
+      /* Allow IRCops to see invisible users. --Runt */
+      if (IsAnOper(sptr))
+        showperson = 1;
+#endif
+
       /*
        * Show user if they are on the same channel, or not
        * invisible and on a non secret channel (if any).
@@ -271,7 +284,11 @@
       for (lp = acptr->user->channel; lp; lp = lp->next)
         {
           chptr = lp->value.chptr;
-          member = IsMember(sptr, chptr);
+          member = IsMember(sptr, chptr)
+#ifdef OPERS_SEE_INVISIBLE
+                   || IsAnOper(sptr);
+#endif
+                   ;
           if (isinvis && !member)
             continue;
           if (member || (!isinvis && PubChannel(chptr)))
diff -uNrd ircd-hybrid-6.4.1/src/m_whois.c ircd-hyb6.4.1-FDFr5.4/src/m_whois.c
--- ircd-hybrid-6.4.1/src/m_whois.c	Fri Jun 20 09:49:47 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_whois.c	Wed Oct 15 20:38:23 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_whois.c,v 1.14 2003/06/20 13:49:47 ievil Exp $
+ *   $Id: m_whois.c,v 1.4 2003/10/09 03:49:54 jailbird Exp $
  */
 
 #include "m_operspylog.h"
@@ -128,6 +128,7 @@
   int   found, len, mlen;
   static time_t last_used=0L;
   int found_mode;
+  static char tempinfo[BUFSIZE+1];
   int whois_len = 4;
 
 #ifdef OPERSPY
@@ -135,7 +136,6 @@
   int OperSpyWhois = 0;
 #endif
 
-
   if (parc < 2)
     {
       sendto_one(sptr, form_str(ERR_NONICKNAMEGIVEN),
@@ -236,9 +236,17 @@
 
           a2cptr = find_server(user->server);
           
-          sendto_one(sptr, form_str(RPL_WHOISUSER), me.name,
-                     parv[0], name,
-                     acptr->username, acptr->host, acptr->info);
+          /* Okay. Let's redo this one. The old code would show the IP
+             if the client was local. Since giving this information to
+             everybody would defeat the purpose for I:-line spoofing,
+             let's only give it out to IRCops. -JailBird */
+          if (MyClient(acptr) && IsAnOper(sptr)) {
+            sprintf(tempinfo,"(%s)",inetntoa((char *)&acptr->ip));
+            sendto_one(sptr, form_str(RPL_WHOISUSER), me.name, parv[0], name,
+                       acptr->username, acptr->host, acptr->info, tempinfo);
+          } else
+            sendto_one(sptr, form_str(RPL_WHOISUSER), me.name, parv[0], name,
+                       acptr->username, acptr->host, acptr->info, "");
 
           mlen = strlen(me.name) + strlen(parv[0]) + 6 +
             strlen(name);
diff -uNrd ircd-hybrid-6.4.1/src/match.c ircd-hyb6.4.1-FDFr5.4/src/match.c
--- ircd-hybrid-6.4.1/src/match.c	Sat Dec  8 02:06:14 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/match.c	Wed Oct 15 20:38:22 2003
@@ -22,7 +22,7 @@
  * Cleanup of collapse and match
  * Moved static calls variable to match
  * Added asserts for null pointers
- * $Id: match.c,v 1.28 2001/12/08 07:06:14 lusky Exp $
+ * $Id: match.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  *
  */
 #include "irc_string.h"
diff -uNrd ircd-hybrid-6.4.1/src/messages_cust.tab ircd-hyb6.4.1-FDFr5.4/src/messages_cust.tab
--- ircd-hybrid-6.4.1/src/messages_cust.tab	Sat Aug 16 15:58:36 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/messages_cust.tab	Wed Oct 15 20:38:22 2003
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: messages_cust.tab,v 1.27 2003/08/16 19:58:36 ievil Exp $
+ * $Id: messages_cust.tab,v 1.7 2003/10/09 03:49:54 jailbird Exp $
  *
  */
 /* 
@@ -25,7 +25,7 @@
 
 static  char *  replies[] = {
 /* 000 */       NULL,
-/* 001  RPL_WELCOME, */ ":%s 001 %s :Welcome to the Internet Relay Network %s",
+/* 001  RPL_WELCOME, */ ":%s 001 %s :Welcome to %s, %s!!!",
 /* 002  RPL_YOURHOST,*/ ":%s 002 %s :Your host is %s, running version %s",
 /* 003  RPL_CREATED, */ ":%s 003 %s :This server was created %s",
 /* 004  RPL_MYINFO, */ ":%s 004 %s %s %s oOiwszcrkfydnxb biklmnopstve",
@@ -266,10 +266,10 @@
 /* 239 */       NULL,
 /* 240 */       NULL,
 /* 241 RPL_STATSLLINE, */       ":%s 241 %s %c %s * %s %d %d",
-/* 242 RPL_STATSUPTIME,*/       ":%s 242 %s :Dianora hasn't messed with the server code now in %d days, %d:%02d:%02d",
+/* 242 RPL_STATSUPTIME,*/       ":%s 242 %s :JailBird hasn't messed with the server code now in %d days, %d:%02d:%02d",
 /* 243 RPL_STATSOLINE, */       ":%s 243 %s %c %s@%s * %s %s %d %s",
 /* 244 RPL_STATSHLINE, */       ":%s 244 %s %c %s * %s %d %d", 
-/* 245 RPL_STATSSLINE, */       ":%s 245 %s %c %s * %s %d %d", 
+/* 245 RPL_STATSSLINE, */       ":%s 245 %s S %s %s",
 /* 246 */       NULL,
 /* 247 RPL_STATSXLINE, */       ":%s 247 %s X %s %s * * 0 0",
 
@@ -343,7 +343,7 @@
 #endif
 /* 309 */       NULL,
 /* 310 */       NULL,
-/* 311 RPL_WHOISUSER, */        ":%s 311 %s %s %s %s * :%s",
+/* 311 RPL_WHOISUSER, */        ":%s 311 %s %s %s %s * :%s %s",
 /* 312 RPL_WHOISSERVER, */      ":%s 312 %s %s %s :%s",
 /* 313 RPL_WHOISOPERATOR, */    ":%s 313 %s %s :is a Smurf Target (IRC Operator)",
 /* 314 RPL_WHOWASUSER, */       ":%s 314 %s %s %s %s * :%s",
@@ -365,11 +365,7 @@
 /* 330 */       NULL,
 /* 331 RPL_NOTOPIC, */          ":%s 331 %s %s :No topic is set.",
 /* 332 RPL_TOPIC, */            ":%s 332 %s %s :%s",
-#ifdef TOPIC_INFO
 /* 333 RPL_TOPICWHOTIME, */     ":%s 333 %s %s %s %lu",
-#else
-/* 333 */       NULL,
-#endif
 /* 334 */       NULL,
 /* 335 */       NULL,
 /* 336 */       NULL,
@@ -382,17 +378,9 @@
 /* 343 */       NULL,
 /* 344 */       NULL,
 /* 345 */       NULL,
-#ifdef BAN_INFO
 /* 346 RPL_INVEXLIST */         ":xs 346 %s %s %s %s %lu",
-#else
-/* 346 RPL_INVEXTLIST */        ":xs 346 %s %s %s %s",
-#endif
 /* 347 RPL_ENDOFINVEXLIST */    ":%s 347 %s %s :End of Channel Invite List",
-#ifdef BAN_INFO
 /* 348 RPL_EXCEPTLIST */        ":%s 348 %s %s %s %s %lu",
-#else
-/* 348 RPL_EXCEPTLIST */        ":%s 348 %s %s %s",
-#endif
 /* 349 RPL_ENDOFEXCEPTLIST */   ":%s 349 %s %s :End of Channel Exception List",
 /* 350 */       NULL,
 /* 351 RPL_VERSION, */          ":%s 351 %s %s(%s).%s %s :%s",
@@ -411,11 +399,7 @@
 /* 364 RPL_LINKS, */            ":%s 364 %s %s %s :%d %s",
 /* 365 RPL_ENDOFLINKS, */       ":%s 365 %s %s :End of /LINKS list.",
 /* 366 RPL_ENDOFNAMES, */       ":%s 366 %s %s :End of /NAMES list.",
-#ifdef BAN_INFO
 /* 367 RPL_BANLIST, */          ":%s 367 %s %s %s %s %lu",
-#else
-/* 367 RPL_BANLIST, */          ":%s 367 %s %s %s",
-#endif
 /* 368 RPL_ENDOFBANLIST, */     ":%s 368 %s %s :End of Channel Ban List",
 /* 369 RPL_ENDOFWHOWAS, */      ":%s 369 %s %s :End of WHOWAS",
 /* 370 */       NULL,
@@ -457,7 +441,7 @@
 /* 406 ERR_WASNOSUCHNICK, */    ":%s 406 %s %s :There was no such nickname",
 /* 407 ERR_TOOMANYTARGETS, */
                 ":%s 407 %s %s :Duplicate recipients. No message delivered.",
-/* 408 */       NULL,
+/* 408 ERR_NOCOLORSONCHAN */    ":%s 408 %s %s :You cannot use colors on this channel. Not sent: %s",
 /* 409 ERR_NOORIGIN, */         ":%s 409 %s :No origin specified",
 /* 410 */       NULL,
 /* 411 ERR_NORECIPIENT, */      ":%s 411 %s :No recipient given (%s)",
@@ -489,7 +473,7 @@
 /* 436 ERR_NICKCOLLISION, */    ":%s 436 %s %s :Nickname collision KILL",
 /* 437 ERR_UNAVAILRESOURCE, */  ":%s 437 %s %s :Nick/channel is temporarily unavailable",
 /* 438 ERR_NICKTOOFAST */       ":%s 438 %s %s %s :Nick change too fast. Please wait %d seconds.",
-/* 439 */       NULL,
+/* 439 ERR_BANNICKCHANGE */	":%s 439 %s %s :Cannot change nickname while banned on channel",
 /* 440 */       NULL,
 /* 441 ERR_USERNOTINCHANNEL, */ ":%s 441 %s %s %s :They aren't on that channel",
 /* 442 ERR_NOTONCHANNEL, */     ":%s 442 %s %s :You're not on that channel",
diff -uNrd ircd-hybrid-6.4.1/src/motd.c ircd-hyb6.4.1-FDFr5.4/src/motd.c
--- ircd-hybrid-6.4.1/src/motd.c	Tue Jul 17 21:37:15 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/motd.c	Wed Oct 15 20:38:23 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: motd.c,v 1.24 2001/07/18 01:37:15 lusky Exp $
+ *   $Id: motd.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "m_commands.h"
 #include "motd.h"
diff -uNrd ircd-hybrid-6.4.1/src/mtrie_conf.c ircd-hyb6.4.1-FDFr5.4/src/mtrie_conf.c
--- ircd-hybrid-6.4.1/src/mtrie_conf.c	Sat Jun 14 21:49:44 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/mtrie_conf.c	Wed Oct 15 20:38:23 2003
@@ -43,7 +43,7 @@
  *
  * Diane Bruce -db (db@db.net)
  *
- * $Id: mtrie_conf.c,v 1.93 2003/06/15 01:49:44 ievil Exp $
+ * $Id: mtrie_conf.c,v 1.1.1.2 2003/10/09 02:47:15 jailbird Exp $
  */
 #include "mtrie_conf.h"
 #include "class.h"
diff -uNrd ircd-hybrid-6.4.1/src/numeric.c ircd-hyb6.4.1-FDFr5.4/src/numeric.c
--- ircd-hybrid-6.4.1/src/numeric.c	Wed Nov 21 20:19:21 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/numeric.c	Wed Oct 15 20:38:22 2003
@@ -19,7 +19,7 @@
  *
  *      I kind of modernized this code a bit. -Dianora
  *
- *   $Id: numeric.c,v 1.4 2001/11/22 01:19:21 db Exp $
+ *   $Id: numeric.c,v 1.2 2003/05/15 21:46:53 jailbird Exp $
  */
 #include "numeric.h"
 #include "irc_string.h"
@@ -27,11 +27,7 @@
 
 #include <assert.h>
 
-#ifdef CUSTOM_ERR            /* XXX ick */
 #include "messages_cust.tab"
-#else
-#include "messages.tab"
-#endif
 
 char numbuff[512];
 
diff -uNrd ircd-hybrid-6.4.1/src/opers.motd ircd-hyb6.4.1-FDFr5.4/src/opers.motd
--- ircd-hybrid-6.4.1/src/opers.motd	Wed Dec 31 19:00:00 1969
+++ ircd-hyb6.4.1-FDFr5.4/src/opers.motd	Wed Oct 15 20:38:23 2003
@@ -0,0 +1 @@
+WELCOME, YOU SEXY IRCOP STUD YOU!!!
diff -uNrd ircd-hybrid-6.4.1/src/packet.c ircd-hyb6.4.1-FDFr5.4/src/packet.c
--- ircd-hybrid-6.4.1/src/packet.c	Sun Dec  9 21:56:29 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/packet.c	Wed Oct 15 20:38:22 2003
@@ -18,7 +18,7 @@
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  *
- *   $Id: packet.c,v 1.25 2001/12/10 02:56:29 jdc Exp $
+ *   $Id: packet.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */ 
 #include "packet.h"
 #include "client.h"
